﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.OleDb;

namespace BancoAccess
{
    class Program
    {
        public class Agenda
        {
            public int Id { get; set; }
            public string Nome { get; set; }
            public string Email { get; set; }

            public void NovaPessoa()
            {
                Console.Write("Digite o novo nome: ");
                this.Nome = Console.ReadLine();
                Console.Write("Digite o novo e-mail: ");
                this.Email = Console.ReadLine();
            }

            public void PreencherPessoa(OleDbDataReader pessoa)
            {
                this.Nome = pessoa["nome"].ToString();
                this.Id = pessoa.GetInt32(0);
                //this.Id = Convert.ToInt32(pessoa["Id"].ToString());
                this.Email = pessoa.GetString(2);
            }

            public void MostrarPessoa()
            { 
                Console.WriteLine("{0}\t{1}\t\t{2}",this.Id.ToString(),this.Nome,this.Email);
            }

            
        }


        public static class AcessoaoAccess
        {
            public static OleDbConnection AbrirConexao()
            {
                return new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=D:\sergio\teste.mdb");
            }

            public static void Mostrar()
            {
                OleDbConnection conexao = AbrirConexao();
                OleDbCommand comando = new OleDbCommand("Select * from agenda", conexao);
                try
                {
                    conexao.Open();
                    OleDbDataReader resposta = comando.ExecuteReader();
                    Console.WriteLine("\nConteúdo da tabela Agenda do banco teste.mdb");
                    Console.WriteLine("\nId\tNome\t\te-mail");
                    while (resposta.Read())
                    {
                        Console.WriteLine("{0}\t{1}\t\t{2}", resposta[0], resposta.GetString(1), resposta["email"]);
                    }
                    resposta.Close();
                    conexao.Close();
                }
                catch(OleDbException e)
                {
                    Console.WriteLine("Erro: {0}", e.Errors[0].Message);
                }

            }

            public static void Incluir(Agenda novo)
            {
                OleDbConnection conexao = AbrirConexao();
                OleDbCommand comando = new OleDbCommand();
                comando.CommandText = "Insert into agenda (nome,email) values (\"" + novo.Nome + "\",\"" + novo.Email + "\")";
                //comando.CommandText = "Insert into agenda (nome,email) values (\"Sérgio Portari\",\"portari@gmail.com\")";
                comando.Connection = conexao;
                try
                {
                    conexao.Open();
                    comando.ExecuteNonQuery();
                    conexao.Close();
                }
                catch (OleDbException e)
                { 
                   Console.WriteLine("Erro: {0}",e.Errors[0].Message);
                }
            }

            public static void Buscar(string qualNome)
            {
                Agenda encontrado = new Agenda();
                OleDbConnection conexao = AbrirConexao();
                OleDbCommand comando = new OleDbCommand();
                comando.Connection = conexao;
                comando.CommandText = "Select * from agenda where nome = \"" + qualNome + "\"";
                OleDbDataReader resultado;
                try
                {
                    conexao.Open();
                    resultado = comando.ExecuteReader();
                    
                    if (resultado.HasRows)
                    {
                        Console.WriteLine("Id\tNome\t\tE-mail");
                        while (resultado.Read())
                        {
                            encontrado.PreencherPessoa(resultado);
                            encontrado.MostrarPessoa();
                        }
                    }
                    else
                    {
                        Console.WriteLine("{0} não encontrado!", qualNome);
                    }
                    conexao.Close();
                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
            }

            public static void Apagar(string qualNome)
            {
                Agenda encontrado = new Agenda();
                OleDbConnection conexao = AbrirConexao();
                OleDbCommand comando = new OleDbCommand();
                comando.Connection = conexao;
                comando.CommandText = "Select * from agenda where nome = \"" + qualNome + "\"";
                OleDbDataReader resultado;
                try
                {
                    conexao.Open();
                    resultado = comando.ExecuteReader();

                    if (resultado.HasRows)
                    {
                        string resp;
                        Console.WriteLine("Id\tNome\t\tE-mail");
                        while (resultado.Read())
                        {
                            encontrado.PreencherPessoa(resultado);
                            encontrado.MostrarPessoa();
                            Console.Write("Deseja apagar este registro? (S/N): ");
                            resp = Console.ReadLine();
                            if (resp.ToUpper() == "S")
                            {
                                OleDbCommand cmd = new OleDbCommand();
                                cmd.CommandText = "Delete from agenda where Id = " + encontrado.Id.ToString();
                                cmd.Connection = conexao;
                                cmd.ExecuteNonQuery();
                                Console.WriteLine("{0} excluído com sucesso", encontrado.Nome);
                            }
                            else
                            {
                                Console.WriteLine("{0} não excluído.", encontrado.Nome);
                            }
                        }
                    }
                    else
                    {
                        Console.WriteLine("{0} não encontrado!", qualNome);
                    }
                    conexao.Close();
                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
            }

            public static void Alterar(string qualNome)
            {
                Agenda encontrado = new Agenda();
                OleDbConnection conexao = AbrirConexao();
                OleDbCommand comando = new OleDbCommand();
                comando.Connection = conexao;
                comando.CommandText = "Select * from agenda where nome = \"" + qualNome + "\"";
                OleDbDataReader resultado;
                try
                {
                    conexao.Open();
                    resultado = comando.ExecuteReader();

                    if (resultado.HasRows)
                    {
                        string resp;
                        Console.WriteLine("Id\tNome\t\tE-mail");
                        while (resultado.Read())
                        {
                            encontrado.PreencherPessoa(resultado);
                            encontrado.MostrarPessoa();
                            Console.Write("Deseja alterar este registro? (S/N): ");
                            resp = Console.ReadLine();
                            if (resp.ToUpper() == "S")
                            {
                                OleDbCommand cmd = new OleDbCommand();
                                string nome, email;
                                Console.Write("Digite o novo nome (ENTER para não alterar): ");
                                nome = Console.ReadLine();
                                if (nome != "")
                                    encontrado.Nome = nome;
                                Console.Write("Digite o novo e-mail (ENTER para não alterar): ");
                                email = Console.ReadLine();
                                if (email != "")
                                    encontrado.Email = email;
                                cmd.CommandText = "Update agenda set nome = \"" + encontrado.Nome + "\", email = \"" + encontrado.Email + "\" where id = " + encontrado.Id;
                                cmd.Connection = conexao;
                                cmd.ExecuteNonQuery();
                                Console.WriteLine("Registro gravado com sucesso");
                            }
                            else
                            {
                                Console.WriteLine("{0} não alterado.", encontrado.Nome);
                            }
                        }
                    }
                    else
                    {
                        Console.WriteLine("{0} não encontrado!", qualNome);
                    }
                    conexao.Close();
                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
            }


        }
       
        static void Main(string[] args)
        {
            Agenda contatinhos = new Agenda();
            string resp;
            do
            {
                Console.WriteLine("\t\tAGENDA PESSOAL");
                Console.WriteLine("\n\t1 - Incluir pessoa\n\t2 - Alterar pessoa\n\t3 - Procurar pessoa\n\t4 - Apagar Pessoa\n\t5 - Listar todos\n\n\t0 - Sair");
                Console.Write("Escolha sua opção: ");
                resp = Console.ReadLine();
                switch (resp)
                {
                    case "1":
                        {
                            contatinhos.NovaPessoa();
                            AcessoaoAccess.Incluir(contatinhos);
                            break;
                        }
                    case "2":
                        {
                            Console.Write("Qual nome quer alterar no banco? ");
                            AcessoaoAccess.Alterar(Console.ReadLine());
                            break;
                        }
                    case "3":
                        { 
                            Console.Write("Qual nome quer procurar no banco? ");
                            AcessoaoAccess.Buscar(Console.ReadLine());
                            break;
                        }
                    case "4":
                        {
                            Console.Write("Qual nome quer apagar no banco? ");
                            AcessoaoAccess.Apagar(Console.ReadLine());
                            break;
                        }
                    case "5":
                        {
                            Console.WriteLine("Mostrando todos");
                            AcessoaoAccess.Mostrar();
                            break;
                        }
                    case "0":
                        {
                            Console.WriteLine("Até breve...");
                            break;
                        }
                    default:
                        {
                            Console.WriteLine("Opção Inválida!");
                            break;
                        }
                }
            } while (resp != "0");
            
           
            Console.ReadKey();
        }
    }
}
